#! /usr/bin/env python
import sys, os, time

sys.path.insert(0,os.pardir)	# to find testserver.py

import testserver
import time
import Pyro.core

######## testclass objects

class IOtestclass(Pyro.core.ObjBase):
	def process(s, name, conn, period):
		print 'called by',name,conn
		time.sleep(period)
		return 'READY!'

class CPUtestclass(Pyro.core.ObjBase):
	def process(s,name, conn, period):
		print 'called by',name,conn
		begin = time.time()
		print 'begin=',begin
		i=0
		while time.time()-begin < period:
			i=i+1
			if i%5000 == 0:
				print name,i
		print 'ready',name,conn
		return 'READY!',conn

######## main program

if raw_input('multithreaded? y/n: ')=='y':
	Pyro.config.PYRO_MULTITHREADED = 1
	print 'Using multithreaded server.'
else:
	Pyro.config.PYRO_MULTITHREADED = 0
	print 'Using singlethreaded server.'
if raw_input('IO bound or CPU bound? io/cpu: ')=='io':
	testclass = IOtestclass
	print 'Using IO bound server.'
else:
	testclass = CPUtestclass
	print 'Using CPU bound server.'

testserver.start(testclass,'multithread')

